<?php

$install_path = $_SERVER["DOCUMENT_ROOT"];
$config = $install_path . "/common/common.inc.php";

if(isset($_POST['install_path'])){
	$install_path = $_POST['install_path'];
	$config = $install_path . "/common/common.inc.php";
	
	if(file_exists($config)){
		
		include_once($config);
		
		SOY2DAOConfig::Dsn(ADMIN_DB_DSN);
		SOY2DAOConfig::user(ADMIN_DB_USER);
		SOY2DAOConfig::pass(ADMIN_DB_PASS);
		
		if(isset($_POST["userid"]) && $_POST["password"]){
			$res = login_check($_POST["userid"],$_POST["password"]);
		}
		
		if($res){
		
			outputHeader();
			
			if(isset($_POST["passwords"])){
				execute($_POST["passwords"]);
			}else{
				outputForm($install_path,$_POST["userid"],$_POST["password"]);
			}
			
			outputFooter();
			
			exit;
		
		}else{
			$error = 2;
		}
		
	}else{
		$error = 1;
	}
}

outputHeader();
if(@$error)outputError($error);
outputBody();
outputFooter();

/* --------------------------------------------------------------------------------------- */

function outputBody(){
	global $install_path;
	
	$path = htmlspecialchars($install_path,ENT_QUOTES);

echo <<<HTML
<form method="post">
	<p>SOYCMSのインストール先を選択してください。</p>
	<input type="text" name="install_path" value="$path" size="120" />
	
	<p>初期管理者のユーザIDとパスワードを入力して下さい</p>
	ユーザID:<input type="text" name="userid" size="10" /><br />
	パスワード:<input type="password" name="password" size="10" />
	
	<p>
		<input type="submit" value="実行" />
	</p>
</form>
HTML;
}

function outputError($error){
	if($error == 1){
		echo "<p style='color:red'>指定された場所にはSOYCMSがインストールされていません。</p>";
	}else{
		echo "<p style='color:red'>初期総合管理者のIDとパスが違います</p>";
	}	
}

function login_check($userid,$password){
	
	$dao = SOY2DAOFactory::create("admin.AdministratorDAO");
	
	try{		
		$bean = $dao->getByUserId($userid);
	}catch(Exception $e){
		return false;
	}
	
	//new type
	if($bean->getUserId() == $userid && $bean->getUserPassword() == crypt($password,$userid)){
		return true;
	
	//old type
	}else if($bean->getUserId() == $userid && $bean->getUserPassword() == crypt($userid,$password)){
		return true;
	}else{
		return false;
	}
}

function outputForm($install_path,$userid,$password){

echo <<<SCRIPT
<script type="text/javascript">
function set_random_password(id){
	ele = document.getElementById(id);
	if(!ele)return;
	
	var a = 'abcdefghijklmnopqrstuvwxyz'
		+ 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
		+ '0123456789';
		
	a = a.split('');
	
	res = "";
	
	for(var i=0; i<10; i++){
		res += a[Math.floor(Math.random() * a.length)];
	}
	
	
	ele.value = res;
	
}
</script>
SCRIPT;

echo '<form method="post">';
echo '<input type="hidden" name="install_path" value="'.htmlspecialchars($install_path,ENT_QUOTES).'" />';
echo '<input type="hidden" name="userid" value="'.htmlspecialchars($userid,ENT_QUOTES).'" />';
echo '<input type="hidden" name="password" value="'.htmlspecialchars($password,ENT_QUOTES).'" />';

$adminDao = SOY2DAOFactory::create("admin.AdministratorDAO");
$administrators = $adminDao->get();

echo '<table border="1">';
echo '<tr><th>ユーザID</th><th>パスワード</th><th></th>';

foreach($administrators as $administrator){
	echo '<tr><td>' . $administrator->getUserId() . "</td>";
	echo '<td><input type="text" id="passwords_'.$administrator->getId().'" name="passwords['.$administrator->getId().']" value="'.$administrator->getUserId().'" onfocus="this.selectr();" />';
	echo '</td><td><a href="javascript:void(0);" onclick="set_random_password(\'passwords_'.$administrator->getId().'\')">生成</a>';
	echo '</td></tr>';
}

echo '</table>';

echo <<<HTML_FORM
	<p>
		<input type="submit" value="実行" />
	</p>
HTML_FORM;

echo '</form>';

}


function outputHeader(){
	echo <<<HEADER_HTML
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>SOYCMS Version Up Program</title>
</head>
<body>
<h1>SOYCMS パスワード再設定プログラム</h1>
HEADER_HTML;
}

function outputFooter(){
	echo <<<FOOTER_HTML
</body>
</html>
FOOTER_HTML;
}


/**
 * バージョンアップ実行
 */
function execute($array){
	
	$dao = SOY2DAOFactory::create("admin.AdministratorDAO");
	$logic = SOY2Logic::createInstance("logic.admin.Administrator.AdministratorLogic");
	
	foreach($array as $id => $value){
		$entity = $dao->getById($id);
		$logic->updateAdministratorPassword($id,$value);
		
		echo $entity->getUserId() . "のパスワードを「".$value."」に変更しました";
		echo "<br />";
	}
	
	echo "パスワードの更新が完了しました。このファイルを削除してください。";
	
}
?>